/* Inspired by the Java Tutorialls exampel,
 * https://docs.oracle.com/javase/tutorial/essential/concurrency/simple.html
 */

class SimpleThreads {

    synchronized static void printMessage(String msg) throws InterruptedException {
        char[] cs= msg.toCharArray();
        for (int i= 0; i< msg.length(); i++) {
            System.out.print(cs[i]);
            Thread.sleep((int)(Math.random() * 100));
        }
    }

    private static class MessageLoop implements Runnable {
        private String msg;
        MessageLoop(String msg) { this.msg= msg; }

        public void run() {
            int c= 2+(int)(Math.random() *3);
            try {
                for (int i = 0; i < c; i++) {
                    Thread.sleep((int)(Math.random() * 100));
                    // Print a message
                    printMessage(msg);
                }
                // System.out.println("Done ("+Thread.currentThread().getName()+")");
            } catch (InterruptedException e) {
                System.out.println("Hey, I wasn't done!");
            }
        }
    }

    public static void main(String args[])
        throws InterruptedException {
        Thread[] threads= new Thread[5];
        String msgs[] = { "One ", "Two ", "Three ", "Four ", "Five " };

        for (int i=0; i< threads.length; i++) {
           threads[i]= new Thread(new MessageLoop(msgs[i]));
        }

        for (Thread t : threads) {
           t.start();
        }

        // wait until threads exit
        for (Thread t : threads) {
            t.join();
        }
        System.out.println("We're done.");
    }
}